#!/usr/bin/perl
###
chdir('../');
###
if($ENV{'CONTENT_LENGTH'}){
	read(STDIN,$FORM,$ENV{'CONTENT_LENGTH'});
}else{
	$FORM=$ENV{'QUERY_STRING'};
}
$STYLE=&GetValue($FORM,'STYLE') || '0';
$STYLE=0 if(!-d("style/$STYLE"));
$CMD=&GetValue($FORM,'CMD');
$CC=&GetValue($FORM,'CC');
&ReadStyle;
&CategoryAdd if($CMD eq 'CA');
&CategoryDel if($CMD eq 'CD');
&CategoryChange if($CMD eq 'CC');
&OutHtml(&MakeHtml(&SiteDel)) if($CMD eq 'SD');
&OutHtml(&MakeHtml(&NewChecked)) if($CMD eq 'NC');
&OutHtml(&NewSite) if(-s("new.dat") && !$CC);
&OutHtml(&MakeHtml($CC));
###
sub HtmlDel{
	my(@dir,$f,$c,%list);
	$c=$_[0];
	while($c=~s/(C\d+)$//){
		$list{$c.$1}=1;
	}
	opendir(DIR,"html");
	@dir=readdir(DIR);
	closedir(DIR);
	foreach $f(@dir){
		unlink("html/$f") if(($f=~/^(\w+)-\w+\.html$/ && $list{$1}) || $f=~/^-/);
	}
	return;
}
###
sub SiteDel{
	my($c,@c,@cc,$url,@list,$i,$root,$sd);
	$c=&UrlUnescape(&GetValue($FORM,'CC'));
	$url=&UrlUnescape(&GetValue($FORM,'URL'));
	$url=~s/\?/\\\?/;
	$root=$url;
	$root=~s/^(.+\/)[^\/]*$/$1/;
	return if(!-e("site/$c.dat"));
	open(FILE,"site.dat");
	flock(FILE,1);
	@list=<FILE>;
	close(FILE);
	for($i=0;$i<=$#list;$i++){
		if($list[$i]=~/^$root<(.+)/){
			@c=split(/,/,$1);
			for(0..$#c){
				push(@cc,$c[$_]) if($c[$_] ne $c);
			}
			if(defined(@cc)){
				$list[$i]="$root<".join(',',@cc)."\n";
			}else{
				$list[$i]='';
			}
		}
	}
	open(FILE,"+<site.dat");
	flock(FILE,2);
	seek(FILE,0,0);
	print FILE join('',@list);
	truncate(FILE,tell(FILE));
	close(FILE);
	open(FILE,"site/$c.dat");
	flock(FILE,1);
	@list=<FILE>;
	close(FILE);
	for($i=0;$i<=$#list;$i++){
		if($list[$i]=~/^$url</){
			$sd=$list[$i];
			$list[$i]='';
		}
	}
	open(FILE,"+>site/$c.dat");
	flock(FILE,2);
	print FILE join('',@list);
	close(FILE);
	&HtmlDel($c);
	return($c,$root,$sd);
}
###
sub CategoryChange{
	my($i,$c,@c,$m,$sd,$nc,$root,@list);
	($c,$root,$sd)=&SiteDel;
	$nc=&UrlUnescape(&GetValue($FORM,'NC'));
	open(FILE,"site.dat");
	flock(FILE,1);
	@list=<FILE>;
	close(FILE);
	for($i=0;$i<=$#list;$i++){
		if($list[$i]=~/^$root<(.+)/){
			@c=split(/,/,$1);
			$list[$i]='';
		}
	}
	foreach(@c){
		$m=1 if($_ eq $nc);
	}
	push(@c,$nc) if(!$m);
	push(@list,"$root<".join(',',@c)."\n");
	@list=sort(@list);
	open(FILE,"+<site.dat");
	flock(FILE,2);
	seek(FILE,0,0);
	print FILE join('',@list);
	truncate(FILE,tell(FILE));
	close(FILE);
	open(FILE,">>site/$nc.dat");
	flock(FILE,2);
	print FILE $sd;
	close(FILE);
	&HtmlDel($nc);
	&OutHtml(&MakeHtml($c));
}
###
sub CategoryDel{
	my($c,@list);
	$c=&UrlUnescape(&GetValue($FORM,'CC'));
	return if(!$c);
	unlink("category/$c.dat");
	open(FILE,"site.dat");
	flock(FILE,1);
	@list=<FILE>;
	close(FILE);
	for($i=0;$i<=$#list;$i++){
		$list[$i]='' if($list[$i]=~/<$c$/);
	}
	open(FILE,"+<site.dat");
	flock(FILE,2);
	seek(FILE,0,0);
	print FILE join('',@list);
	truncate(FILE,tell(FILE));
	close(FILE);
	unlink("site/$c.dat");
	&HtmlDel($c);
	$c=~s/C\d+$//;
	&OutHtml(&MakeHtml($c));
}
###
sub CategoryAdd{
	my($name,$i);
	$c=&UrlUnescape(&GetValue($FORM,'CC'));
	$name=&UrlUnescape(&GetValue($FORM,'NAME'));
	for($i=0;1;$i++){
		if(!-e("category/${c}C$i.dat")){
			open(FILE,"+>category/${c}C$i.dat");
			print FILE $name;
			close(FILE);
			last;
		}
	}
	&HtmlDel($c);
	return;
}
###
sub NewSite{
	my($result,@list,$i,@line);
	open(FILE,"new.dat");
	flock(FILE,1);
	@list=<FILE>;
	close(FILE);
	for($i=0;$i<=$#list;$i++){
		@line=split(/</,$list[$i]);
		$result.=&InsertString($Style{'and'},$line[1],$line[0],$line[2],$line[3]);
	}
	$result=&InsertString($Style{'anf'},$result);
	$result=&InsertString($Style{'admin'},$result);
	return($result);
}
###
sub NewChecked{
	open(FILE,"+>new.dat");
	close(FILE);
	return;
}
###
sub MakeHtml{
	my($c,@category,$cco,$ccf,@dir,$file,@list,%list,$cf,$cc,$sf,$cp,$time,@time);
	$c=$_[0];
	opendir(DIR,"category");
	@dir=readdir(DIR);
	closedir(DIR);
	foreach(@dir){
		next if(/^\./);
		/^([^\.]+)\./;
		open(FILE,"category/$1.dat");
		flock(FILE,1);
		$file=join('',<FILE>);
		close(FILE);
		$list{$1}=$file;
	}
	@category=sort {$a cmp $b} keys(%list);
	foreach(@category){
		$cco.=&InsertString($Style{'acco'},$_,"$_ : $list{$_}") if($_ ne $c);
		$cf.=&InsertString($Style{'acd'},$list{$_},$_) if(/^${c}C\d+$/);
	}
	$cf=&InsertString($Style{'acf'},$cf) if($cf);
	$cf=&InsertString($Style{'acdel'},$c) if(!$cf && $c);
	$cc=$c;
	while($cc=~s/(C\d+)$//){
		open(FILE,"category/$cc$1.dat");
		flock(FILE,1);
		$file=join('',<FILE>);
		close(FILE);
		$cp=&InsertString($Style{'acp'},$file,$cc.$1).$cp;
	}
	open(FILE,"site/$c.dat");
	flock(FILE,1);
	@list=<FILE>;
	close(FILE);
	for($i=0;$i<=$#list;$i++){
		@line=split(/[<\n]/,$list[$i]);
		$time="";
		if($line[3]){
			@time=localtime($line[3]);
			$time[5]+=1900;
			$time[4]++;
			for(0..4){
				$time[$_]="0$time[$_]" if(length($time[$_])==1);
			}
			$time="$time[5]/$time[4]/$time[3] $time[2]:$time[1]:$time[0]";
		}
		$ccf=&InsertString($Style{'accf'},$c,$line[0],$cco);
		$sf.=&InsertString($Style{'asd'},$line[1],$line[0],$line[2],$c,$ccf,$time);
	}
	$sf=&InsertString($Style{'asf'},$sf);
	$result=&InsertString($Style{'admin'},$cf,$c,$cp,$sf);
	return($result);
}
###
sub InsertString{
	my($result);
	$result=$_[0];
	$result=~s/\$SCRIPT\((\d+)\)/$_[$1]/g;
	return($result);
}
###
sub ReadStyle{
	my(@dir);
	opendir(DIR,"style/$STYLE");
	@dir=readdir(DIR);
	closedir(DIR);
	foreach(@dir){
		if(/^(\w+)\.dat$/){
			$Style{$1}="";
			open(FILE,"style/$STYLE/$1.dat");
			while(<FILE>){
				$Style{$1}.=$_;
			}
			close(FILE);
		}
	}
	return;
}
###
sub GetValue{
	my(@objects,@name);
	@objects=split(/[&;]/,$_[0]);
	foreach(@objects){
		push(@name,$1) if(/^$_[1]=(.+)$/);
	}
	return($name[0]) if($#name<1);
	return(@name);
}
###
sub UrlUnescape{
	my($str,$head);
	$str=$_[0];
	$head='%';
	$str=~tr/+/ /;
	$str=~s/$head([0-9A-Fa-f][0-9A-Fa-f])/pack("H2",$1)/eg;
	return($str);
}
###
sub OutHtml{
	print "content-type:text/html\n\n";
	print $_[0];
	exit;
}
###

