#!/usr/bin/perl
###
$MaxName=200;
$MaxUrl=200;
$MaxComment=1000;
$MaxSite=10000;
###
if($ENV{'CONTENT_LENGTH'}){
	read(STDIN,$FORM,$ENV{'CONTENT_LENGTH'});
}else{
	$FORM=$ENV{'QUERY_STRING'};
}
$STYLE=&GetValue($FORM,'STYLE') || '0';
$STYLE=0 if($STYLE=~/\// || $STYLE=~/^\./);
$CMD=&GetValue($FORM,'CMD');
$CC=&UrlUnescape(&GetValue($FORM,'CC'));
die('error') if($CC=~/\// || $CC=~/^\./);
&ReadStyle;
&OutHtml(&SiteAdd) if($CMD eq 'SA');
&OutHtml(&MakeHtml);
###
sub HtmlDel{
	my(@dir,$f,$c,%list);
	$c=$_[0];
	while($c=~s/(C\d+)$//){
		$list{$c.$1}=1;
	}
	opendir(DIR,"html");
	@dir=readdir(DIR);
	closedir(DIR);
	foreach $f(@dir){
		unlink("html/$f") if($f=~/^(\w+)-\w+\.html$/ && $list{$1});
	}
	return;
}
###
sub SiteAdd{
	my($i,$name,$url,$comment,$error,@list,@line,$root,@c,$m);
	$url=&UrlUnescape(&GetValue($FORM,'URL'));
	$name=&UrlUnescape(&GetValue($FORM,'NAME'));
	$comment=&UrlUnescape(&GetValue($FORM,'COMMENT'));
	$url=~s/[\r\n\s<>]//g;
	$name=~s/[\r\n<>]//g;
	$comment=~s/[\r\n<>]/ /g;
	$root=$url;
	$root=~s/^(.+\/)[^\/]*$/$1/;
	$error=$Style{'e0'}.' ' if(!$url || length($url)>$MaxUrl || $url!~/http:\/\/[\w\/\.\?\-\+\=\#\~\%\&]+/ || $root!~/^http:\/\/[^\/].+\/$/);
	$error=$Style{'e1'}.' ' if(!$name || length($name)>$MaxName);
	$error=$Style{'e2'}.' ' if(!$comment || length($comment)>$MaxComment);
	$error=$Style{'e3'}.' ' if(!-e("category/$CC.dat"));
	return(&InsertString($Style{'regist'},$CC,$error,$name,$url,$comment)) if($error);
	open(FILE,"site.dat");
	flock(FILE,1);
	@list=<FILE>;
	close(FILE);
	return(&InsertString($Style{'regist'},$CC,$Style{'e4'},$name,$url,$comment)) if($#list>$MaxSite);
	for($i=0;$i<=$#list;$i++){
		if($list[$i]=~/^$root<(.+)/){
			@c=split(/,/,$1);
			$list[$i]='';
		}
	}
	foreach(@c){
		$m=1 if($_ eq $CC);
	}
	push(@c,$CC) if(!$m);
	push(@list,"$root<".join(',',@c)."\n");
	@list=sort(@list);
	open(FILE,"+<site.dat");
	flock(FILE,2);
	seek(FILE,0,0);
	print FILE join('',@list);
	truncate(FILE,tell(FILE));
	close(FILE);
	open(FILE,"site/$CC.dat");
	flock(FILE,1);
	@list=<FILE>;
	close(FILE);
	for($i=0;$i<=$#list;$i++){
		@line=split(/</,$list[$i]);
		$list[$i]='' if($line[0] eq $url);
	}
	push(@list,"$url<$name<$comment<\n");
	open(FILE,"+>site/$CC.dat");
	flock(FILE,2);
	seek(FILE,0,0);
	print FILE join('',@list);
	truncate(FILE,tell(FILE));
	close(FILE);
	open(FILE,">>new.dat");
	flock(FILE,2);
	print FILE "$url<$name<$comment<$CC<\n";
	close(FILE);
	&HtmlDel($CC);
	return(&InsertString($Style{'r0'},$CC,$name,$url,$comment));
}
###
sub MakeHtml{
	my($result);
	$result=&InsertString($Style{'regist'},$CC);
	return($result);
}
###
sub InsertString{
	my($result);
	$result=$_[0];
	$result=~s/\$SCRIPT\((\d+)\)/$_[$1]/g;
	return($result);
}
###
sub ReadStyle{
	my(@dir);
	opendir(DIR,"style/$STYLE");
	@dir=readdir(DIR);
	closedir(DIR);
	foreach(@dir){
		if(/^(\w+)\.dat$/){
			$Style{$1}="";
			open(FILE,"style/$STYLE/$1.dat");
			while(<FILE>){
				$Style{$1}.=$_;
			}
			close(FILE);
		}
	}
	return;
}
###
sub GetValue{
	my(@objects,@name);
	@objects=split(/[&;]/,$_[0]);
	foreach(@objects){
		push(@name,$1) if(/^$_[1]=(.+)$/);
	}
	return($name[0]) if($#name<1);
	return(@name);
}
###
sub UrlUnescape{
	my($str,$head);
	$str=$_[0];
	$head='%';
	$str=~tr/+/ /;
	$str=~s/$head([0-9A-Fa-f][0-9A-Fa-f])/pack("H2",$1)/eg;
	return($str);
}
###
sub OutHtml{
	print "content-type:text/html\n\n";
	print $_[0];
	exit;
}
###

